"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerlessWorkflowTextEditorView = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var api_1 = require("@kie-tools-core/guided-tour/dist/api");
var React = require("react");
var ServerlessWorkflowTextEditor_1 = require("./ServerlessWorkflowTextEditor");
var ServerlessWorkflowTextEditorView = (function () {
    function ServerlessWorkflowTextEditorView(envelopeContext, initArgs) {
        this.envelopeContext = envelopeContext;
        this.initArgs = initArgs;
        this.af_isReact = true;
        this.editorRef = React.createRef();
    }
    ServerlessWorkflowTextEditorView.prototype.getElementPosition = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, api_1.DEFAULT_RECT];
            });
        });
    };
    ServerlessWorkflowTextEditorView.prototype.setContent = function (path, content) {
        return this.editorRef.current.setContent(path, content);
    };
    ServerlessWorkflowTextEditorView.prototype.getContent = function () {
        return this.editorRef.current.getContent();
    };
    ServerlessWorkflowTextEditorView.prototype.getPreview = function () {
        return this.editorRef.current.getPreview();
    };
    ServerlessWorkflowTextEditorView.prototype.af_componentRoot = function () {
        return ((0, jsx_runtime_1.jsx)(ServerlessWorkflowTextEditor_1.ServerlessWorkflowTextEditor, { ref: this.editorRef, isReadOnly: this.initArgs.isReadOnly, channelType: this.initArgs.channel, onNewEdit: this.envelopeContext.channelApi.notifications.kogitoWorkspace_newEdit.send, onStateControlCommandUpdate: this.envelopeContext.channelApi.notifications.kogitoEditor_stateControlCommandUpdate.send, setNotifications: this.envelopeContext.channelApi.notifications.kogitoNotifications_setNotifications.send }, void 0));
    };
    ServerlessWorkflowTextEditorView.prototype.undo = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.editorRef.current.undo()];
            });
        });
    };
    ServerlessWorkflowTextEditorView.prototype.redo = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.editorRef.current.redo()];
            });
        });
    };
    ServerlessWorkflowTextEditorView.prototype.validate = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.editorRef.current.validate()];
            });
        });
    };
    ServerlessWorkflowTextEditorView.prototype.setTheme = function (theme) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.editorRef.current.setTheme(theme)];
            });
        });
    };
    ServerlessWorkflowTextEditorView.prototype.moveCursorToNode = function (nodeName) {
        var _a;
        (_a = this.editorRef.current) === null || _a === void 0 ? void 0 : _a.moveCursorToNode(nodeName);
    };
    return ServerlessWorkflowTextEditorView;
}());
exports.ServerlessWorkflowTextEditorView = ServerlessWorkflowTextEditorView;
//# sourceMappingURL=ServerlessWorkflowTextEditorView.js.map